((typeof self !== 'undefined' ? self : this)["webpackJsonpcontractor_management_sm"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpcontractor_management_sm"] || []).push([[33],{

/***/ "2148":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var ERROR_CODES = ['ECONNRESET', 'ETIMEDOUT', 'EADDRINFO', 'ESOCKETTIMEDOUT'];

/**
 * Determine if a request should be retried.
 * (Borrowed from segmentio/superagent-retry)
 *
 * @param {Error} err
 * @param {Response} [res]
 * @returns {Boolean}
 */
module.exports = function shouldRetry(err, res) {
  if (err && err.code && ~ERROR_CODES.indexOf(err.code)) return true;
  if (res && res.status && res.status >= 500) return true;
  // Superagent timeout
  if (err && 'timeout' in err && err.code == 'ECONNABORTED') return true;
  if (err && 'crossDomain' in err) return true;
  return false;
};

/***/ }),

/***/ "2160":
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer, module) {var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;var _classCallCheck = __webpack_require__("970b").default;
var _createClass = __webpack_require__("5bc3").default;
var _typeof = __webpack_require__("7037").default;
__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("944a");
__webpack_require__("d9e2");
__webpack_require__("4de4");
__webpack_require__("caad");
__webpack_require__("a15b");
__webpack_require__("d81d");
__webpack_require__("b0c0");
__webpack_require__("6c57");
__webpack_require__("0c47");
__webpack_require__("23dc");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
__webpack_require__("ac1f");
__webpack_require__("25f0");
__webpack_require__("466d");
__webpack_require__("5319");
__webpack_require__("0643");
__webpack_require__("2382");
__webpack_require__("4e3e");
__webpack_require__("a573");
__webpack_require__("159b");
__webpack_require__("c73d");
(function (p, m) {
  ( false ? undefined : _typeof(exports)) == "object" && ( false ? undefined : _typeof(module)) < "u" ? m(exports, __webpack_require__("784b")) :  true ? !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports, __webpack_require__("784b")], __WEBPACK_AMD_DEFINE_FACTORY__ = (m),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)) : (undefined);
})(this, function (p, m) {
  "use strict";

  var F = Object.defineProperty;
  var R = function R(p, m, a) {
    return m in p ? F(p, m, {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: a
    }) : p[m] = a;
  };
  var C = function C(p, m, a) {
    return R(p, _typeof(m) != "symbol" ? m + "" : m, a), a;
  };
  var _f = /*#__PURE__*/function () {
    function f() {
      _classCallCheck(this, f);
      this.basePath = "/".replace(/\/+$/, ""), this.authentications = {
        oauth2: {
          type: "oauth2"
        }
      }, this.defaultHeaders = {}, this.timeout = 6e4, this.cache = !0, this.enableCookies = !1, (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && (this.agent = new m.agent()), this.requestAgent = null;
    }
    return _createClass(f, [{
      key: "paramToString",
      value: function paramToString(e) {
        return e == null || e == null ? "" : e instanceof Date ? e.toJSON() : e.toString();
      }
    }, {
      key: "buildUrl",
      value: function buildUrl(e, t) {
        var _this = this;
        e.match(/^\//) || (e = "/" + e);
        var r = this.basePath + e;
        return r = r.replace(/\{([\w-]+)\}/g, function (n, i) {
          var s;
          return t.hasOwnProperty(i) ? s = _this.paramToString(t[i]) : s = n, encodeURIComponent(s);
        }), r;
      }
    }, {
      key: "isJsonMime",
      value: function isJsonMime(e) {
        return !!(e != null && e.match(/^application\/json(;.*)?$/i));
      }
    }, {
      key: "jsonPreferredMime",
      value: function jsonPreferredMime(e) {
        for (var t = 0; t < e.length; t++) if (this.isJsonMime(e[t])) return e[t];
        return e[0];
      }
    }, {
      key: "isFileParam",
      value: function isFileParam(e) {
        if (true) {
          var t;
          try {
            t = __webpack_require__(3);
          } catch (_unused) {}
          if (t && t.ReadStream && e instanceof t.ReadStream) return !0;
        }
        return typeof Buffer == "function" && e instanceof Buffer || typeof Blob == "function" && e instanceof Blob || typeof File == "function" && e instanceof File;
      }
    }, {
      key: "normalizeParams",
      value: function normalizeParams(e) {
        var t = {};
        for (var r in e) if (e.hasOwnProperty(r) && e[r] != null && e[r] != null) {
          var n = e[r];
          this.isFileParam(n) || Array.isArray(n) ? t[r] = n : t[r] = this.paramToString(n);
        }
        return t;
      }
    }, {
      key: "buildCollectionParam",
      value: function buildCollectionParam(e, t) {
        if (e == null) return null;
        switch (t) {
          case "csv":
            return e.map(this.paramToString).join(",");
          case "ssv":
            return e.map(this.paramToString).join(" ");
          case "tsv":
            return e.map(this.paramToString).join("	");
          case "pipes":
            return e.map(this.paramToString).join("|");
          case "multi":
            return e.map(this.paramToString);
          default:
            throw new Error("Unknown collection format: " + t);
        }
      }
    }, {
      key: "applyAuthToRequest",
      value: function applyAuthToRequest(e, t) {
        var _this2 = this;
        t.forEach(function (r) {
          var n = _this2.authentications[r];
          switch (n.type) {
            case "basic":
              (n.username || n.password) && e.auth(n.username || "", n.password || "");
              break;
            case "apiKey":
              if (n.apiKey) {
                var i = {};
                n.apiKeyPrefix ? i[n.name] = n.apiKeyPrefix + " " + n.apiKey : i[n.name] = n.apiKey, n.in === "header" ? e.set(i) : e.query(i);
              }
              break;
            case "oauth2":
              n.accessToken && e.set({
                Authorization: "Bearer " + n.accessToken
              });
              break;
            default:
              throw new Error("Unknown authentication type: " + n.type);
          }
        });
      }
    }, {
      key: "deserialize",
      value: function deserialize(e, t) {
        if (e == null || e.status == 204) return null;
        var r = e.body;
        if ((r == null || _typeof(r) == "object" && _typeof(r.length) > "u" && !Object.keys(r).length) && (r = e.text), t == null && ["easc3"].includes("setting-management")) return {
          data: r
        };
        var n = _f.convertToType(r.data, t);
        return {
          code: r.code,
          data: n
        };
      }
    }, {
      key: "callApi",
      value: function callApi(e, t, r, n, i, s, o, u, c, h, O) {
        var _this3 = this;
        var U = this.buildUrl(e, r),
          l = m(t, U);
        this.applyAuthToRequest(l, u), t.toUpperCase() === "GET" && this.cache === !1 && (n._ = new Date().getTime()), l.query(this.normalizeParams(n)), l.set(this.defaultHeaders).set(this.normalizeParams(i)), this.requestAgent && l.agent(this.requestAgent), l.timeout(this.timeout);
        var v = this.jsonPreferredMime(c);
        if (v ? v != "multipart/form-data" && l.type(v) : l.header["Content-Type"] || l.type("application/json"), v === "application/x-www-form-urlencoded") l.send(_f.stringify(this.normalizeParams(s)));else if (v == "multipart/form-data") {
          var w = this.normalizeParams(s);
          for (var P in w) w.hasOwnProperty(P) && (this.isFileParam(w[P]) ? l.attach(P, w[P]) : l.field(P, w[P]));
        } else o && l.send(o);
        var N = this.jsonPreferredMime(h);
        return N && l.accept(N), O === "Blob" ? l.responseType("blob") : O === "String" && l.responseType("string"), this.enableCookies && ((typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" ? this.agent.attachCookies(l) : l.withCredentials()), new Promise(function (x, E) {
          l.end(function (B, I) {
            if (B) E(B);else try {
              var H = _this3.deserialize(I, O);
              _this3.enableCookies && (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && _this3.agent.saveCookies(I), x({
                data: H,
                response: I
              });
            } catch (W) {
              E(W);
            }
          });
        });
      }
    }], [{
      key: "parseDate",
      value: function parseDate(e) {
        return new Date(e);
      }
    }, {
      key: "convertToType",
      value: function convertToType(e, t) {
        if (e == null) return e;
        switch (t) {
          case "Boolean":
            return !!e;
          case "Integer":
            return parseInt(e, 10);
          case "Number":
            return parseFloat(e);
          case "String":
            return String(e);
          case "Date":
            return _f.parseDate(String(e));
          case "Blob":
            return e;
          default:
            if (t === Object) return e;
            if (typeof t == "function") return t.constructFromObject(e);
            if (Array.isArray(t)) {
              var r = t[0];
              return e.map(function (h) {
                return _f.convertToType(h, r);
              });
            } else if (_typeof(t) == "object") {
              var n, i;
              for (var s in t) if (t.hasOwnProperty(s)) {
                n = s, i = t[s];
                break;
              }
              var o = {};
              for (var s in e) if (e.hasOwnProperty(s)) {
                var u = _f.convertToType(s, n),
                  c = _f.convertToType(e[s], i);
                o[u] = c;
              }
              return o;
            } else return e;
        }
      }
    }, {
      key: "constructFromObject",
      value: function constructFromObject(e, t, r) {
        if (Array.isArray(e)) for (var n = 0; n < e.length; n++) e.hasOwnProperty(n) && (t[n] = _f.convertToType(e[n], r));else for (var i in e) e.hasOwnProperty(i) && (t[i] = _f.convertToType(e[i], r));
      }
    }, {
      key: "GetInstance",
      value: function GetInstance(e, t) {
        return Wiz ? Wiz.GetApiClientInstance(e, t) : new _f();
      }
    }, {
      key: "stringifyPrimitive",
      value: function stringifyPrimitive(e) {
        switch (_typeof(e)) {
          case "string":
            return e;
          case "boolean":
            return e ? "true" : "false";
          case "number":
            return isFinite(e) ? e : "";
          default:
            return "";
        }
      }
    }, {
      key: "stringify",
      value: function stringify(e, t, r, n) {
        return t = t || "&", r = r || "=", e === null && (e = void 0), _typeof(e) == "object" ? Object.keys(e).map(function (i) {
          var s = encodeURIComponent(_f.stringifyPrimitive(i)) + r;
          return Array.isArray(e[i]) ? e[i].map(function (o) {
            return s + encodeURIComponent(_f.stringifyPrimitive(o));
          }).join(t) : s + encodeURIComponent(_f.stringifyPrimitive(e[i]));
        }).filter(Boolean).join(t) : n ? encodeURIComponent(_f.stringifyPrimitive(n)) + r + encodeURIComponent(_f.stringifyPrimitive(e)) : "";
      }
    }]);
  }();
  var a = _f;
  C(a, "CollectionFormatEnum", {
    CSV: ",",
    SSV: " ",
    TSV: "	",
    PIPES: "|",
    MULTI: "multi"
  });
  var T = /*#__PURE__*/function () {
    function T() {
      _classCallCheck(this, T);
    }
    return _createClass(T, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new T(), e.hasOwnProperty("message") && (t.message = a.convertToType(e.message, "String")), e.hasOwnProperty("members") && (t.members = a.convertToType(e.members, ["String"]))), t;
      }
    }]);
  }();
  T.prototype.message = void 0, T.prototype.members = void 0;
  var y = /*#__PURE__*/function () {
    function y() {
      _classCallCheck(this, y);
    }
    return _createClass(y, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new y(), e.hasOwnProperty("code") && (t.code = a.convertToType(e.code, "String")), e.hasOwnProperty("message") && (t.message = a.convertToType(e.message, "String")), e.hasOwnProperty("details") && (t.details = a.convertToType(e.details, "String")), e.hasOwnProperty("data") && (t.data = a.convertToType(e.data, {
          String: Object
        })), e.hasOwnProperty("validationErrors") && (t.validationErrors = a.convertToType(e.validationErrors, [T]))), t;
      }
    }]);
  }();
  y.prototype.code = void 0, y.prototype.message = void 0, y.prototype.details = void 0, y.prototype.data = void 0, y.prototype.validationErrors = void 0;
  var S = /*#__PURE__*/function () {
    function S() {
      _classCallCheck(this, S);
    }
    return _createClass(S, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new S(), e.hasOwnProperty("error") && (t.error = y.constructFromObject(e.error))), t;
      }
    }]);
  }();
  S.prototype.error = void 0;
  var g = /*#__PURE__*/function () {
    function g() {
      _classCallCheck(this, g);
    }
    return _createClass(g, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new g(), e.hasOwnProperty("name") && (t.name = a.convertToType(e.name, "String")), e.hasOwnProperty("displayName") && (t.displayName = a.convertToType(e.displayName, "String")), e.hasOwnProperty("description") && (t.description = a.convertToType(e.description, "String")), e.hasOwnProperty("value") && (t.value = a.convertToType(e.value, "String")), e.hasOwnProperty("properties") && (t.properties = a.convertToType(e.properties, {
          String: Object
        })), e.hasOwnProperty("permission") && (t.permission = a.convertToType(e.permission, "String"))), t;
      }
    }]);
  }();
  g.prototype.name = void 0, g.prototype.displayName = void 0, g.prototype.description = void 0, g.prototype.value = void 0, g.prototype.properties = void 0, g.prototype.permission = void 0;
  var d = /*#__PURE__*/function () {
    function d() {
      _classCallCheck(this, d);
    }
    return _createClass(d, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new d(), e.hasOwnProperty("groupName") && (t.groupName = a.convertToType(e.groupName, "String")), e.hasOwnProperty("groupDisplayName") && (t.groupDisplayName = a.convertToType(e.groupDisplayName, "String")), e.hasOwnProperty("settingInfos") && (t.settingInfos = a.convertToType(e.settingInfos, [g])), e.hasOwnProperty("permission") && (t.permission = a.convertToType(e.permission, "String"))), t;
      }
    }]);
  }();
  d.prototype.groupName = void 0, d.prototype.groupDisplayName = void 0, d.prototype.settingInfos = void 0, d.prototype.permission = void 0;
  var A = /*#__PURE__*/function () {
    function A(e) {
      _classCallCheck(this, A);
      this.apiClient = e || a.GetInstance("setting-management", "SettingApi");
    }
    return _createClass(A, [{
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'settingName' when calling get");
        var r = {
            settingName: e
          },
          n = {},
          i = {},
          s = {},
          o = ["oauth2"],
          u = [],
          c = ["text/plain", "application/json", "text/json"],
          h = g;
        return this.apiClient.callApi("/api/setting-management/settings/{settingName}", "GET", r, n, i, s, t, o, u, c, h);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          n = {},
          i = {},
          s = ["oauth2"],
          o = [],
          u = ["text/plain", "application/json", "text/json"],
          c = [d];
        return this.apiClient.callApi("/api/setting-management/settings", "GET", t, r, n, i, e, s, o, u, c);
      }
    }, {
      key: "getList",
      value: function getList() {
        return this.getListWithHttpInfo();
      }
    }, {
      key: "getValueWithHttpInfo",
      value: function getValueWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'settingName' when calling getValue");
        var r = {
            settingName: e
          },
          n = {},
          i = {},
          s = {},
          o = ["oauth2"],
          u = [],
          c = ["text/plain", "application/json", "text/json"],
          h = "String";
        return this.apiClient.callApi("/api/setting-management/settings/value/{settingName}", "GET", r, n, i, s, t, o, u, c, h);
      }
    }, {
      key: "getValue",
      value: function getValue(e) {
        return this.getValueWithHttpInfo(e);
      }
    }, {
      key: "resetWithHttpInfo",
      value: function resetWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          n = {},
          i = e.header || {},
          s = {},
          o = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          c = ["text/plain", "application/json", "text/json"],
          h = e.returnType || null;
        return this.apiClient.callApi("/api/setting-management/settings/reset", "PUT", r, n, i, s, t, o, u, c, h);
      }
    }, {
      key: "reset",
      value: function reset(e) {
        return this.resetWithHttpInfo(e);
      }
    }, {
      key: "resetSettingPropertyCacheWithHttpInfo",
      value: function resetSettingPropertyCacheWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          n = {},
          i = {},
          s = ["oauth2"],
          o = [],
          u = ["text/plain", "application/json", "text/json"],
          c = null;
        return this.apiClient.callApi("/api/setting-management/settings/reset-setting-property-cache", "GET", t, r, n, i, e, s, o, u, c);
      }
    }, {
      key: "resetSettingPropertyCache",
      value: function resetSettingPropertyCache() {
        return this.resetSettingPropertyCacheWithHttpInfo();
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          n = {
            settingName: e.settingName,
            settingValue: e.settingValue
          },
          i = e.header || {},
          s = {},
          o = ["oauth2"],
          u = [],
          c = ["text/plain", "application/json", "text/json"],
          h = e.returnType || null;
        return this.apiClient.callApi("/api/setting-management/settings", "PUT", r, n, i, s, t, o, u, c, h);
      }
    }, {
      key: "update",
      value: function update(e) {
        return this.updateWithHttpInfo(e);
      }
    }, {
      key: "update_0WithHttpInfo",
      value: function update_0WithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          n = {},
          i = e.header || {},
          s = {},
          o = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          c = ["text/plain", "application/json", "text/json"],
          h = e.returnType || null;
        return this.apiClient.callApi("/api/setting-management/settings/many", "PUT", r, n, i, s, t, o, u, c, h);
      }
    }, {
      key: "update_0",
      value: function update_0(e) {
        return this.update_0WithHttpInfo(e);
      }
    }]);
  }();
  C(A, "Methods", {
    get: {
      desc: "获取设置信息",
      method: "GET",
      path: "/api/setting-management/settings/{settingName}"
    },
    getList: {
      desc: "分组获取设置信息",
      method: "GET",
      path: "/api/setting-management/settings"
    },
    getValue: {
      desc: "获取设置值",
      method: "GET",
      path: "/api/setting-management/settings/value/{settingName}"
    },
    reset: {
      desc: "重置设置为默认值",
      method: "PUT",
      path: "/api/setting-management/settings/reset"
    },
    resetSettingPropertyCache: {
      desc: "重置设置属性缓存",
      method: "GET",
      path: "/api/setting-management/settings/reset-setting-property-cache"
    },
    update: {
      desc: "设置设置值",
      method: "PUT",
      path: "/api/setting-management/settings"
    },
    update_0: {
      desc: "设置设置值",
      method: "PUT",
      path: "/api/setting-management/settings/many"
    }
  }), p.AbpRemoteServiceErrorInfo = y, p.AbpRemoteServiceErrorResponse = S, p.AbpRemoteServiceValidationErrorInfo = T, p.ApiClient = a, p.SettingApi = A, p.SettingManagementSettingGroup = d, p.SettingManagementSettingInfo = g, Object.defineProperty(p, Symbol.toStringTag, {
    value: "Module"
  });
});
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__("b639").Buffer, __webpack_require__("62e4")(module)))

/***/ }),

/***/ "3c6f":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Check if `obj` is an object.
 *
 * @param {Object} obj
 * @return {Boolean}
 * @api private
 */
var _typeof = __webpack_require__("7037").default;
function isObject(obj) {
  return null !== obj && 'object' === _typeof(obj);
}
module.exports = isObject;

/***/ }),

/***/ "55d4":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Return the mime type for the given `str`.
 *
 * @param {String} str
 * @return {String}
 * @api private
 */
__webpack_require__("fb6a");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("1276");
__webpack_require__("0643");
__webpack_require__("9d4a");
exports.type = function (str) {
  return str.split(/ *; */).shift();
};

/**
 * Return header field parameters.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

exports.params = function (str) {
  return str.split(/ *; */).reduce(function (obj, str) {
    var parts = str.split(/ *= */);
    var key = parts.shift();
    var val = parts.shift();
    if (key && val) obj[key] = val;
    return obj;
  }, {});
};

/**
 * Parse Link header fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

exports.parseLinks = function (str) {
  return str.split(/ *, */).reduce(function (obj, str) {
    var parts = str.split(/ *; */);
    var url = parts[0].slice(1, -1);
    var rel = parts[1].split(/ *= */)[1].slice(1, -1);
    obj[rel] = url;
    return obj;
  }, {});
};

/**
 * Strip content related fields from `header`.
 *
 * @param {Object} header
 * @return {Object} header
 * @api private
 */

exports.cleanHeader = function (header, shouldStripCookie) {
  delete header['content-type'];
  delete header['content-length'];
  delete header['transfer-encoding'];
  delete header['host'];
  if (shouldStripCookie) {
    delete header['cookie'];
  }
  return header;
};

/***/ }),

/***/ "784b":
/***/ (function(module, exports, __webpack_require__) {

var _typeof = __webpack_require__("7037").default;
__webpack_require__("d9e2");
__webpack_require__("a15b");
__webpack_require__("14d9");
__webpack_require__("fb6a");
__webpack_require__("b0c0");
__webpack_require__("e9c4");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("00b4");
__webpack_require__("25f0");
__webpack_require__("5319");
__webpack_require__("1276");
__webpack_require__("498a");
__webpack_require__("0643");
__webpack_require__("4e3e");
__webpack_require__("313d");
__webpack_require__("159b");
__webpack_require__("0eb6");
__webpack_require__("b7ef");
__webpack_require__("8bd4");
__webpack_require__("c73d");
/**
 * Root reference for iframes.
 */

var root;
if (typeof window !== 'undefined') {
  // Browser window
  root = window;
} else if (typeof self !== 'undefined') {
  // Web Worker
  root = self;
} else {
  // Other environments
  console.warn("Using browser-only version of superagent in non-browser environment");
  root = this;
}
var Emitter = __webpack_require__("7297");
var RequestBase = __webpack_require__("ff213");
var isObject = __webpack_require__("3c6f");
var ResponseBase = __webpack_require__("7dab");
var shouldRetry = __webpack_require__("2148");

/**
 * Noop.
 */

function noop() {}
;

/**
 * Expose `request`.
 */

var request = exports = module.exports = function (method, url) {
  // callback
  if ('function' == typeof url) {
    return new exports.Request('GET', method).end(url);
  }

  // url first
  if (1 == arguments.length) {
    return new exports.Request('GET', method);
  }
  return new exports.Request(method, url);
};
exports.Request = Request;

/**
 * Determine XHR.
 */

request.getXHR = function () {
  if (root.XMLHttpRequest && (!root.location || 'file:' != root.location.protocol || !root.ActiveXObject)) {
    return new XMLHttpRequest();
  } else {
    try {
      return new ActiveXObject('Microsoft.XMLHTTP');
    } catch (e) {}
    try {
      return new ActiveXObject('Msxml2.XMLHTTP.6.0');
    } catch (e) {}
    try {
      return new ActiveXObject('Msxml2.XMLHTTP.3.0');
    } catch (e) {}
    try {
      return new ActiveXObject('Msxml2.XMLHTTP');
    } catch (e) {}
  }
  throw Error("Browser-only version of superagent could not find XHR");
};

/**
 * Removes leading and trailing whitespace, added to support IE.
 *
 * @param {String} s
 * @return {String}
 * @api private
 */

var trim = ''.trim ? function (s) {
  return s.trim();
} : function (s) {
  return s.replace(/(^\s*|\s*$)/g, '');
};

/**
 * Serialize the given `obj`.
 *
 * @param {Object} obj
 * @return {String}
 * @api private
 */

function serialize(obj) {
  if (!isObject(obj)) return obj;
  var pairs = [];
  for (var key in obj) {
    pushEncodedKeyValuePair(pairs, key, obj[key]);
  }
  return pairs.join('&');
}

/**
 * Helps 'serialize' with serializing arrays.
 * Mutates the pairs array.
 *
 * @param {Array} pairs
 * @param {String} key
 * @param {Mixed} val
 */

function pushEncodedKeyValuePair(pairs, key, val) {
  if (val != null) {
    if (Array.isArray(val)) {
      val.forEach(function (v) {
        pushEncodedKeyValuePair(pairs, key, v);
      });
    } else if (isObject(val)) {
      for (var subkey in val) {
        pushEncodedKeyValuePair(pairs, key + '[' + subkey + ']', val[subkey]);
      }
    } else {
      pairs.push(encodeURIComponent(key) + '=' + encodeURIComponent(val));
    }
  } else if (val === null) {
    pairs.push(encodeURIComponent(key));
  }
}

/**
 * Expose serialization method.
 */

request.serializeObject = serialize;

/**
 * Parse the given x-www-form-urlencoded `str`.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseString(str) {
  var obj = {};
  var pairs = str.split('&');
  var pair;
  var pos;
  for (var i = 0, len = pairs.length; i < len; ++i) {
    pair = pairs[i];
    pos = pair.indexOf('=');
    if (pos == -1) {
      obj[decodeURIComponent(pair)] = '';
    } else {
      obj[decodeURIComponent(pair.slice(0, pos))] = decodeURIComponent(pair.slice(pos + 1));
    }
  }
  return obj;
}

/**
 * Expose parser.
 */

request.parseString = parseString;

/**
 * Default MIME type map.
 *
 *     superagent.types.xml = 'application/xml';
 *
 */

request.types = {
  html: 'text/html',
  json: 'application/json',
  xml: 'text/xml',
  urlencoded: 'application/x-www-form-urlencoded',
  'form': 'application/x-www-form-urlencoded',
  'form-data': 'application/x-www-form-urlencoded'
};

/**
 * Default serialization map.
 *
 *     superagent.serialize['application/xml'] = function(obj){
 *       return 'generated xml here';
 *     };
 *
 */

request.serialize = {
  'application/x-www-form-urlencoded': serialize,
  'application/json': JSON.stringify
};

/**
 * Default parsers.
 *
 *     superagent.parse['application/xml'] = function(str){
 *       return { object parsed from str };
 *     };
 *
 */

request.parse = {
  'application/x-www-form-urlencoded': parseString,
  'application/json': JSON.parse
};

/**
 * Parse the given header `str` into
 * an object containing the mapped fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseHeader(str) {
  var lines = str.split(/\r?\n/);
  var fields = {};
  var index;
  var line;
  var field;
  var val;
  for (var i = 0, len = lines.length; i < len; ++i) {
    line = lines[i];
    index = line.indexOf(':');
    if (index === -1) {
      // could be empty line, just skip it
      continue;
    }
    field = line.slice(0, index).toLowerCase();
    val = trim(line.slice(index + 1));
    fields[field] = val;
  }
  return fields;
}

/**
 * Check if `mime` is json or has +json structured syntax suffix.
 *
 * @param {String} mime
 * @return {Boolean}
 * @api private
 */

function isJSON(mime) {
  return /[\/+]json\b/.test(mime);
}

/**
 * Initialize a new `Response` with the given `xhr`.
 *
 *  - set flags (.ok, .error, etc)
 *  - parse header
 *
 * Examples:
 *
 *  Aliasing `superagent` as `request` is nice:
 *
 *      request = superagent;
 *
 *  We can use the promise-like API, or pass callbacks:
 *
 *      request.get('/').end(function(res){});
 *      request.get('/', function(res){});
 *
 *  Sending data can be chained:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' })
 *        .end(function(res){});
 *
 *  Or passed to `.send()`:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' }, function(res){});
 *
 *  Or passed to `.post()`:
 *
 *      request
 *        .post('/user', { name: 'tj' })
 *        .end(function(res){});
 *
 * Or further reduced to a single call for simple cases:
 *
 *      request
 *        .post('/user', { name: 'tj' }, function(res){});
 *
 * @param {XMLHTTPRequest} xhr
 * @param {Object} options
 * @api private
 */

function Response(req) {
  this.req = req;
  this.xhr = this.req.xhr;
  // responseText is accessible only if responseType is '' or 'text' and on older browsers
  this.text = this.req.method != 'HEAD' && (this.xhr.responseType === '' || this.xhr.responseType === 'text') || typeof this.xhr.responseType === 'undefined' ? this.xhr.responseText : null;
  this.statusText = this.req.xhr.statusText;
  var status = this.xhr.status;
  // handle IE9 bug: http://stackoverflow.com/questions/10046972/msie-returns-status-code-of-1223-for-ajax-request
  if (status === 1223) {
    status = 204;
  }
  this._setStatusProperties(status);
  this.header = this.headers = parseHeader(this.xhr.getAllResponseHeaders());
  // getAllResponseHeaders sometimes falsely returns "" for CORS requests, but
  // getResponseHeader still works. so we get content-type even if getting
  // other headers fails.
  this.header['content-type'] = this.xhr.getResponseHeader('content-type');
  this._setHeaderProperties(this.header);
  if (null === this.text && req._responseType) {
    this.body = this.xhr.response;
  } else {
    this.body = this.req.method != 'HEAD' ? this._parseBody(this.text ? this.text : this.xhr.response) : null;
  }
}
ResponseBase(Response.prototype);

/**
 * Parse the given body `str`.
 *
 * Used for auto-parsing of bodies. Parsers
 * are defined on the `superagent.parse` object.
 *
 * @param {String} str
 * @return {Mixed}
 * @api private
 */

Response.prototype._parseBody = function (str) {
  var parse = request.parse[this.type];
  if (this.req._parser) {
    return this.req._parser(this, str);
  }
  if (!parse && isJSON(this.type)) {
    parse = request.parse['application/json'];
  }
  return parse && str && (str.length || str instanceof Object) ? parse(str) : null;
};

/**
 * Return an `Error` representative of this response.
 *
 * @return {Error}
 * @api public
 */

Response.prototype.toError = function () {
  var req = this.req;
  var method = req.method;
  var url = req.url;
  var msg = 'cannot ' + method + ' ' + url + ' (' + this.status + ')';
  var err = new Error(msg);
  err.status = this.status;
  err.method = method;
  err.url = url;
  return err;
};

/**
 * Expose `Response`.
 */

request.Response = Response;

/**
 * Initialize a new `Request` with the given `method` and `url`.
 *
 * @param {String} method
 * @param {String} url
 * @api public
 */

function Request(method, url) {
  var self = this;
  this._query = this._query || [];
  this.method = method;
  this.url = url;
  this.header = {}; // preserves header name case
  this._header = {}; // coerces header names to lowercase
  this.on('end', function () {
    var err = null;
    var res = null;
    try {
      res = new Response(self);
    } catch (e) {
      err = new Error('Parser is unable to parse the response');
      err.parse = true;
      err.original = e;
      // issue #675: return the raw response if the response parsing fails
      if (self.xhr) {
        // ie9 doesn't have 'response' property
        err.rawResponse = typeof self.xhr.responseType == 'undefined' ? self.xhr.responseText : self.xhr.response;
        // issue #876: return the http status code if the response parsing fails
        err.status = self.xhr.status ? self.xhr.status : null;
        err.statusCode = err.status; // backwards-compat only
      } else {
        err.rawResponse = null;
        err.status = null;
      }
      return self.callback(err);
    }
    self.emit('response', res);
    var new_err;
    try {
      if (!self._isResponseOK(res)) {
        new_err = new Error(res.statusText || 'Unsuccessful HTTP response');
      }
    } catch (custom_err) {
      new_err = custom_err; // ok() callback can throw
    }

    // #1000 don't catch errors from the callback to avoid double calling it
    if (new_err) {
      new_err.original = err;
      new_err.response = res;
      new_err.status = res.status;
      self.callback(new_err, res);
    } else {
      self.callback(null, res);
    }
  });
}

/**
 * Mixin `Emitter` and `RequestBase`.
 */

Emitter(Request.prototype);
RequestBase(Request.prototype);

/**
 * Set Content-Type to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.xml = 'application/xml';
 *
 *      request.post('/')
 *        .type('xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 *      request.post('/')
 *        .type('application/xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 * @param {String} type
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.type = function (type) {
  this.set('Content-Type', request.types[type] || type);
  return this;
};

/**
 * Set Accept to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.json = 'application/json';
 *
 *      request.get('/agent')
 *        .accept('json')
 *        .end(callback);
 *
 *      request.get('/agent')
 *        .accept('application/json')
 *        .end(callback);
 *
 * @param {String} accept
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.accept = function (type) {
  this.set('Accept', request.types[type] || type);
  return this;
};

/**
 * Set Authorization field value with `user` and `pass`.
 *
 * @param {String} user
 * @param {String} [pass] optional in case of using 'bearer' as type
 * @param {Object} options with 'type' property 'auto', 'basic' or 'bearer' (default 'basic')
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.auth = function (user, pass, options) {
  if (_typeof(pass) === 'object' && pass !== null) {
    // pass is optional and can substitute for options
    options = pass;
  }
  if (!options) {
    options = {
      type: 'function' === typeof btoa ? 'basic' : 'auto'
    };
  }
  switch (options.type) {
    case 'basic':
      this.set('Authorization', 'Basic ' + btoa(user + ':' + pass));
      break;
    case 'auto':
      this.username = user;
      this.password = pass;
      break;
    case 'bearer':
      // usage would be .auth(accessToken, { type: 'bearer' })
      this.set('Authorization', 'Bearer ' + user);
      break;
  }
  return this;
};

/**
 * Add query-string `val`.
 *
 * Examples:
 *
 *   request.get('/shoes')
 *     .query('size=10')
 *     .query({ color: 'blue' })
 *
 * @param {Object|String} val
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.query = function (val) {
  if ('string' != typeof val) val = serialize(val);
  if (val) this._query.push(val);
  return this;
};

/**
 * Queue the given `file` as an attachment to the specified `field`,
 * with optional `options` (or filename).
 *
 * ``` js
 * request.post('/upload')
 *   .attach('content', new Blob(['<a id="a"><b id="b">hey!</b></a>'], { type: "text/html"}))
 *   .end(callback);
 * ```
 *
 * @param {String} field
 * @param {Blob|File} file
 * @param {String|Object} options
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.attach = function (field, file, options) {
  if (file) {
    if (this._data) {
      throw Error("superagent can't mix .send() and .attach()");
    }
    this._getFormData().append(field, file, options || file.name);
  }
  return this;
};
Request.prototype._getFormData = function () {
  if (!this._formData) {
    this._formData = new root.FormData();
  }
  return this._formData;
};

/**
 * Invoke the callback with `err` and `res`
 * and handle arity check.
 *
 * @param {Error} err
 * @param {Response} res
 * @api private
 */

Request.prototype.callback = function (err, res) {
  // console.log(this._retries, this._maxRetries)
  if (this._maxRetries && this._retries++ < this._maxRetries && shouldRetry(err, res)) {
    return this._retry();
  }
  var fn = this._callback;
  this.clearTimeout();
  if (err) {
    if (this._maxRetries) err.retries = this._retries - 1;
    this.emit('error', err);
  }
  fn(err, res);
};

/**
 * Invoke callback with x-domain error.
 *
 * @api private
 */

Request.prototype.crossDomainError = function () {
  var err = new Error('Request has been terminated\nPossible causes: the network is offline, Origin is not allowed by Access-Control-Allow-Origin, the page is being unloaded, etc.');
  err.crossDomain = true;
  err.status = this.status;
  err.method = this.method;
  err.url = this.url;
  this.callback(err);
};

// This only warns, because the request is still likely to work
Request.prototype.buffer = Request.prototype.ca = Request.prototype.agent = function () {
  console.warn("This is not supported in browser version of superagent");
  return this;
};

// This throws, because it can't send/receive data as expected
Request.prototype.pipe = Request.prototype.write = function () {
  throw Error("Streaming is not supported in browser version of superagent");
};

/**
 * Check if `obj` is a host object,
 * we don't want to serialize these :)
 *
 * @param {Object} obj
 * @return {Boolean}
 * @api private
 */
Request.prototype._isHost = function _isHost(obj) {
  // Native objects stringify to [object File], [object Blob], [object FormData], etc.
  return obj && 'object' === _typeof(obj) && !Array.isArray(obj) && Object.prototype.toString.call(obj) !== '[object Object]';
};

/**
 * Initiate request, invoking callback `fn(res)`
 * with an instanceof `Response`.
 *
 * @param {Function} fn
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.end = function (fn) {
  if (this._endCalled) {
    console.warn("Warning: .end() was called twice. This is not supported in superagent");
  }
  this._endCalled = true;

  // store callback
  this._callback = fn || noop;

  // querystring
  this._finalizeQueryString();
  return this._end();
};
Request.prototype._end = function () {
  var self = this;
  var xhr = this.xhr = request.getXHR();
  var data = this._formData || this._data;
  this._setTimeouts();

  // state change
  xhr.onreadystatechange = function () {
    var readyState = xhr.readyState;
    if (readyState >= 2 && self._responseTimeoutTimer) {
      clearTimeout(self._responseTimeoutTimer);
    }
    if (4 != readyState) {
      return;
    }

    // In IE9, reads to any property (e.g. status) off of an aborted XHR will
    // result in the error "Could not complete the operation due to error c00c023f"
    var status;
    try {
      status = xhr.status;
    } catch (e) {
      status = 0;
    }
    if (!status) {
      if (self.timedout || self._aborted) return;
      return self.crossDomainError();
    }
    self.emit('end');
  };

  // progress
  var handleProgress = function handleProgress(direction, e) {
    if (e.total > 0) {
      e.percent = e.loaded / e.total * 100;
    }
    e.direction = direction;
    self.emit('progress', e);
  };
  if (this.hasListeners('progress')) {
    try {
      xhr.onprogress = handleProgress.bind(null, 'download');
      if (xhr.upload) {
        xhr.upload.onprogress = handleProgress.bind(null, 'upload');
      }
    } catch (e) {
      // Accessing xhr.upload fails in IE from a web worker, so just pretend it doesn't exist.
      // Reported here:
      // https://connect.microsoft.com/IE/feedback/details/837245/xmlhttprequest-upload-throws-invalid-argument-when-used-from-web-worker-context
    }
  }

  // initiate request
  try {
    if (this.username && this.password) {
      xhr.open(this.method, this.url, true, this.username, this.password);
    } else {
      xhr.open(this.method, this.url, true);
    }
  } catch (err) {
    // see #1149
    return this.callback(err);
  }

  // CORS
  if (this._withCredentials) xhr.withCredentials = true;

  // body
  if (!this._formData && 'GET' != this.method && 'HEAD' != this.method && 'string' != typeof data && !this._isHost(data)) {
    // serialize stuff
    var contentType = this._header['content-type'];
    var serialize = this._serializer || request.serialize[contentType ? contentType.split(';')[0] : ''];
    if (!serialize && isJSON(contentType)) {
      serialize = request.serialize['application/json'];
    }
    if (serialize) data = serialize(data);
  }

  // set header fields
  for (var field in this.header) {
    if (null == this.header[field]) continue;
    if (this.header.hasOwnProperty(field)) xhr.setRequestHeader(field, this.header[field]);
  }
  if (this._responseType) {
    xhr.responseType = this._responseType;
  }

  // send stuff
  this.emit('request', this);

  // IE11 xhr.send(undefined) sends 'undefined' string as POST payload (instead of nothing)
  // We need null here if data is undefined
  xhr.send(typeof data !== 'undefined' ? data : null);
  return this;
};

/**
 * GET `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.get = function (url, data, fn) {
  var req = request('GET', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * HEAD `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.head = function (url, data, fn) {
  var req = request('HEAD', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * OPTIONS query to `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.options = function (url, data, fn) {
  var req = request('OPTIONS', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * DELETE `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

function del(url, data, fn) {
  var req = request('DELETE', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
}
;
request['del'] = del;
request['delete'] = del;

/**
 * PATCH `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.patch = function (url, data, fn) {
  var req = request('PATCH', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * POST `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.post = function (url, data, fn) {
  var req = request('POST', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * PUT `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.put = function (url, data, fn) {
  var req = request('PUT', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/***/ }),

/***/ "7dab":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Module dependencies.
 */
__webpack_require__("9911");
var utils = __webpack_require__("55d4");

/**
 * Expose `ResponseBase`.
 */

module.exports = ResponseBase;

/**
 * Initialize a new `ResponseBase`.
 *
 * @api public
 */

function ResponseBase(obj) {
  if (obj) return mixin(obj);
}

/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in ResponseBase.prototype) {
    obj[key] = ResponseBase.prototype[key];
  }
  return obj;
}

/**
 * Get case-insensitive `field` value.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

ResponseBase.prototype.get = function (field) {
  return this.header[field.toLowerCase()];
};

/**
 * Set header related properties:
 *
 *   - `.type` the content type without params
 *
 * A response of "Content-Type: text/plain; charset=utf-8"
 * will provide you with a `.type` of "text/plain".
 *
 * @param {Object} header
 * @api private
 */

ResponseBase.prototype._setHeaderProperties = function (header) {
  // TODO: moar!
  // TODO: make this a util

  // content-type
  var ct = header['content-type'] || '';
  this.type = utils.type(ct);

  // params
  var params = utils.params(ct);
  for (var key in params) this[key] = params[key];
  this.links = {};

  // links
  try {
    if (header.link) {
      this.links = utils.parseLinks(header.link);
    }
  } catch (err) {
    // ignore
  }
};

/**
 * Set flags such as `.ok` based on `status`.
 *
 * For example a 2xx response will give you a `.ok` of __true__
 * whereas 5xx will be __false__ and `.error` will be __true__. The
 * `.clientError` and `.serverError` are also available to be more
 * specific, and `.statusType` is the class of error ranging from 1..5
 * sometimes useful for mapping respond colors etc.
 *
 * "sugar" properties are also defined for common cases. Currently providing:
 *
 *   - .noContent
 *   - .badRequest
 *   - .unauthorized
 *   - .notAcceptable
 *   - .notFound
 *
 * @param {Number} status
 * @api private
 */

ResponseBase.prototype._setStatusProperties = function (status) {
  var type = status / 100 | 0;

  // status / class
  this.status = this.statusCode = status;
  this.statusType = type;

  // basics
  this.info = 1 == type;
  this.ok = 2 == type;
  this.redirect = 3 == type;
  this.clientError = 4 == type;
  this.serverError = 5 == type;
  this.error = 4 == type || 5 == type ? this.toError() : false;

  // sugar
  this.accepted = 202 == status;
  this.noContent = 204 == status;
  this.badRequest = 400 == status;
  this.unauthorized = 401 == status;
  this.notAcceptable = 406 == status;
  this.forbidden = 403 == status;
  this.notFound = 404 == status;
};

/***/ }),

/***/ "ff213":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Module of mixed-in functions shared between node and client code
 */
var _typeof = __webpack_require__("7037").default;
__webpack_require__("d9e2");
__webpack_require__("a15b");
__webpack_require__("4e82");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
var isObject = __webpack_require__("3c6f");

/**
 * Expose `RequestBase`.
 */

module.exports = RequestBase;

/**
 * Initialize a new `RequestBase`.
 *
 * @api public
 */

function RequestBase(obj) {
  if (obj) return mixin(obj);
}

/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in RequestBase.prototype) {
    obj[key] = RequestBase.prototype[key];
  }
  return obj;
}

/**
 * Clear previous timeout.
 *
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.clearTimeout = function _clearTimeout() {
  clearTimeout(this._timer);
  clearTimeout(this._responseTimeoutTimer);
  delete this._timer;
  delete this._responseTimeoutTimer;
  return this;
};

/**
 * Override default response body parser
 *
 * This function will be called to convert incoming data into request.body
 *
 * @param {Function}
 * @api public
 */

RequestBase.prototype.parse = function parse(fn) {
  this._parser = fn;
  return this;
};

/**
 * Set format of binary response body.
 * In browser valid formats are 'blob' and 'arraybuffer',
 * which return Blob and ArrayBuffer, respectively.
 *
 * In Node all values result in Buffer.
 *
 * Examples:
 *
 *      req.get('/')
 *        .responseType('blob')
 *        .end(callback);
 *
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.responseType = function (val) {
  this._responseType = val;
  return this;
};

/**
 * Override default request body serializer
 *
 * This function will be called to convert data set via .send or .attach into payload to send
 *
 * @param {Function}
 * @api public
 */

RequestBase.prototype.serialize = function serialize(fn) {
  this._serializer = fn;
  return this;
};

/**
 * Set timeouts.
 *
 * - response timeout is time between sending request and receiving the first byte of the response. Includes DNS and connection time.
 * - deadline is the time from start of the request to receiving response body in full. If the deadline is too short large files may not load at all on slow connections.
 *
 * Value of 0 or false means no timeout.
 *
 * @param {Number|Object} ms or {response, deadline}
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.timeout = function timeout(options) {
  if (!options || 'object' !== _typeof(options)) {
    this._timeout = options;
    this._responseTimeout = 0;
    return this;
  }
  for (var option in options) {
    switch (option) {
      case 'deadline':
        this._timeout = options.deadline;
        break;
      case 'response':
        this._responseTimeout = options.response;
        break;
      default:
        console.warn("Unknown timeout option", option);
    }
  }
  return this;
};

/**
 * Set number of retry attempts on error.
 *
 * Failed requests will be retried 'count' times if timeout or err.code >= 500.
 *
 * @param {Number} count
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.retry = function retry(count) {
  // Default to 1 if no count passed or true
  if (arguments.length === 0 || count === true) count = 1;
  if (count <= 0) count = 0;
  this._maxRetries = count;
  this._retries = 0;
  return this;
};

/**
 * Retry request
 *
 * @return {Request} for chaining
 * @api private
 */

RequestBase.prototype._retry = function () {
  this.clearTimeout();

  // node
  if (this.req) {
    this.req = null;
    this.req = this.request();
  }
  this._aborted = false;
  this.timedout = false;
  return this._end();
};

/**
 * Promise support
 *
 * @param {Function} resolve
 * @param {Function} [reject]
 * @return {Request}
 */

RequestBase.prototype.then = function then(resolve, reject) {
  if (!this._fullfilledPromise) {
    var self = this;
    if (this._endCalled) {
      console.warn("Warning: superagent request was sent twice, because both .end() and .then() were called. Never call .end() if you use promises");
    }
    this._fullfilledPromise = new Promise(function (innerResolve, innerReject) {
      self.end(function (err, res) {
        if (err) innerReject(err);else innerResolve(res);
      });
    });
  }
  return this._fullfilledPromise.then(resolve, reject);
};
RequestBase.prototype.catch = function (cb) {
  return this.then(undefined, cb);
};

/**
 * Allow for extension
 */

RequestBase.prototype.use = function use(fn) {
  fn(this);
  return this;
};
RequestBase.prototype.ok = function (cb) {
  if ('function' !== typeof cb) throw Error("Callback required");
  this._okCallback = cb;
  return this;
};
RequestBase.prototype._isResponseOK = function (res) {
  if (!res) {
    return false;
  }
  if (this._okCallback) {
    return this._okCallback(res);
  }
  return res.status >= 200 && res.status < 300;
};

/**
 * Get request header `field`.
 * Case-insensitive.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

RequestBase.prototype.get = function (field) {
  return this._header[field.toLowerCase()];
};

/**
 * Get case-insensitive header `field` value.
 * This is a deprecated internal API. Use `.get(field)` instead.
 *
 * (getHeader is no longer used internally by the superagent code base)
 *
 * @param {String} field
 * @return {String}
 * @api private
 * @deprecated
 */

RequestBase.prototype.getHeader = RequestBase.prototype.get;

/**
 * Set header `field` to `val`, or multiple fields with one object.
 * Case-insensitive.
 *
 * Examples:
 *
 *      req.get('/')
 *        .set('Accept', 'application/json')
 *        .set('X-API-Key', 'foobar')
 *        .end(callback);
 *
 *      req.get('/')
 *        .set({ Accept: 'application/json', 'X-API-Key': 'foobar' })
 *        .end(callback);
 *
 * @param {String|Object} field
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.set = function (field, val) {
  if (isObject(field)) {
    for (var key in field) {
      this.set(key, field[key]);
    }
    return this;
  }
  this._header[field.toLowerCase()] = val;
  this.header[field] = val;
  return this;
};

/**
 * Remove header `field`.
 * Case-insensitive.
 *
 * Example:
 *
 *      req.get('/')
 *        .unset('User-Agent')
 *        .end(callback);
 *
 * @param {String} field
 */
RequestBase.prototype.unset = function (field) {
  delete this._header[field.toLowerCase()];
  delete this.header[field];
  return this;
};

/**
 * Write the field `name` and `val`, or multiple fields with one object
 * for "multipart/form-data" request bodies.
 *
 * ``` js
 * request.post('/upload')
 *   .field('foo', 'bar')
 *   .end(callback);
 *
 * request.post('/upload')
 *   .field({ foo: 'bar', baz: 'qux' })
 *   .end(callback);
 * ```
 *
 * @param {String|Object} name
 * @param {String|Blob|File|Buffer|fs.ReadStream} val
 * @return {Request} for chaining
 * @api public
 */
RequestBase.prototype.field = function (name, val) {
  // name should be either a string or an object.
  if (null === name || undefined === name) {
    throw new Error('.field(name, val) name can not be empty');
  }
  if (this._data) {
    console.error(".field() can't be used if .send() is used. Please use only .send() or only .field() & .attach()");
  }
  if (isObject(name)) {
    for (var key in name) {
      this.field(key, name[key]);
    }
    return this;
  }
  if (Array.isArray(val)) {
    for (var i in val) {
      this.field(name, val[i]);
    }
    return this;
  }

  // val should be defined now
  if (null === val || undefined === val) {
    throw new Error('.field(name, val) val can not be empty');
  }
  if ('boolean' === typeof val) {
    val = '' + val;
  }
  this._getFormData().append(name, val);
  return this;
};

/**
 * Abort the request, and clear potential timeout.
 *
 * @return {Request}
 * @api public
 */
RequestBase.prototype.abort = function () {
  if (this._aborted) {
    return this;
  }
  this._aborted = true;
  this.xhr && this.xhr.abort(); // browser
  this.req && this.req.abort(); // node
  this.clearTimeout();
  this.emit('abort');
  return this;
};

/**
 * Enable transmission of cookies with x-domain requests.
 *
 * Note that for this to work the origin must not be
 * using "Access-Control-Allow-Origin" with a wildcard,
 * and also must set "Access-Control-Allow-Credentials"
 * to "true".
 *
 * @api public
 */

RequestBase.prototype.withCredentials = function (on) {
  // This is browser-only functionality. Node side is no-op.
  if (on == undefined) on = true;
  this._withCredentials = on;
  return this;
};

/**
 * Set the max redirects to `n`. Does noting in browser XHR implementation.
 *
 * @param {Number} n
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.redirects = function (n) {
  this._maxRedirects = n;
  return this;
};

/**
 * Maximum size of buffered response body, in bytes. Counts uncompressed size.
 * Default 200MB.
 *
 * @param {Number} n
 * @return {Request} for chaining
 */
RequestBase.prototype.maxResponseSize = function (n) {
  if ('number' !== typeof n) {
    throw TypeError("Invalid argument");
  }
  this._maxResponseSize = n;
  return this;
};

/**
 * Convert to a plain javascript object (not JSON string) of scalar properties.
 * Note as this method is designed to return a useful non-this value,
 * it cannot be chained.
 *
 * @return {Object} describing method, url, and data of this request
 * @api public
 */

RequestBase.prototype.toJSON = function () {
  return {
    method: this.method,
    url: this.url,
    data: this._data,
    headers: this._header
  };
};

/**
 * Send `data` as the request body, defaulting the `.type()` to "json" when
 * an object is given.
 *
 * Examples:
 *
 *       // manual json
 *       request.post('/user')
 *         .type('json')
 *         .send('{"name":"tj"}')
 *         .end(callback)
 *
 *       // auto json
 *       request.post('/user')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // manual x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send('name=tj')
 *         .end(callback)
 *
 *       // auto x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // defaults to x-www-form-urlencoded
 *      request.post('/user')
 *        .send('name=tobi')
 *        .send('species=ferret')
 *        .end(callback)
 *
 * @param {String|Object} data
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.send = function (data) {
  var isObj = isObject(data);
  var type = this._header['content-type'];
  if (this._formData) {
    console.error(".send() can't be used if .attach() or .field() is used. Please use only .send() or only .field() & .attach()");
  }
  if (isObj && !this._data) {
    if (Array.isArray(data)) {
      this._data = [];
    } else if (!this._isHost(data)) {
      this._data = {};
    }
  } else if (data && this._data && this._isHost(this._data)) {
    throw Error("Can't merge these send calls");
  }

  // merge
  if (isObj && isObject(this._data)) {
    for (var key in data) {
      this._data[key] = data[key];
    }
  } else if ('string' == typeof data) {
    // default to x-www-form-urlencoded
    if (!type) this.type('form');
    type = this._header['content-type'];
    if ('application/x-www-form-urlencoded' == type) {
      this._data = this._data ? this._data + '&' + data : data;
    } else {
      this._data = (this._data || '') + data;
    }
  } else {
    this._data = data;
  }
  if (!isObj || this._isHost(data)) {
    return this;
  }

  // default to json
  if (!type) this.type('json');
  return this;
};

/**
 * Sort `querystring` by the sort function
 *
 *
 * Examples:
 *
 *       // default order
 *       request.get('/user')
 *         .query('name=Nick')
 *         .query('search=Manny')
 *         .sortQuery()
 *         .end(callback)
 *
 *       // customized sort function
 *       request.get('/user')
 *         .query('name=Nick')
 *         .query('search=Manny')
 *         .sortQuery(function(a, b){
 *           return a.length - b.length;
 *         })
 *         .end(callback)
 *
 *
 * @param {Function} sort
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.sortQuery = function (sort) {
  // _sort default to true but otherwise can be a function or boolean
  this._sort = typeof sort === 'undefined' ? true : sort;
  return this;
};

/**
 * Compose querystring to append to req.url
 *
 * @api private
 */
RequestBase.prototype._finalizeQueryString = function () {
  var query = this._query.join('&');
  if (query) {
    this.url += (this.url.indexOf('?') >= 0 ? '&' : '?') + query;
  }
  this._query.length = 0; // Makes the call idempotent

  if (this._sort) {
    var index = this.url.indexOf('?');
    if (index >= 0) {
      var queryArr = this.url.substring(index + 1).split('&');
      if ('function' === typeof this._sort) {
        queryArr.sort(this._sort);
      } else {
        queryArr.sort();
      }
      this.url = this.url.substring(0, index) + '?' + queryArr.join('&');
    }
  }
};

// For backwards compat only
RequestBase.prototype._appendQueryString = function () {
  console.trace("Unsupported");
};

/**
 * Invoke callback with timeout error.
 *
 * @api private
 */

RequestBase.prototype._timeoutError = function (reason, timeout, errno) {
  if (this._aborted) {
    return;
  }
  var err = new Error(reason + timeout + 'ms exceeded');
  err.timeout = timeout;
  err.code = 'ECONNABORTED';
  err.errno = errno;
  this.timedout = true;
  this.abort();
  this.callback(err);
};
RequestBase.prototype._setTimeouts = function () {
  var self = this;

  // deadline
  if (this._timeout && !this._timer) {
    this._timer = setTimeout(function () {
      self._timeoutError('Timeout of ', self._timeout, 'ETIME');
    }, this._timeout);
  }
  // response timeout
  if (this._responseTimeout && !this._responseTimeoutTimer) {
    this._responseTimeoutTimer = setTimeout(function () {
      self._timeoutError('Response timeout of ', self._responseTimeout, 'ETIMEDOUT');
    }, this._responseTimeout);
  }
};

/***/ })

}]);
//# sourceMappingURL=contractor-management-sm.umd.33.js.map